package de.bsvrz.buv.plugin.bmvew;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.rw.rw.menu.ElementRegistrierung;
import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion;

/**
 * {@link IStartup} Implementierung, registriert alle Actions dieses Moduls zwecks Men- und Symbolleistenaufbau bzw.
 * deren Verwaltung.
 * 
 * @version $Revision: 1.2 $ / $Date: 2010/02/04 05:50:35 $ / ($Author: HofmannJ $)
 * 
 * @author HofmannJ
 * 
 */
public class Starter implements IStartup
{
  /**
   * In dieser Methode werden die vom Modul Betriebsmeldungsverwaltung bereitgestellten Actions generiert und in der
   * Klasse {@link ElementRegistrierung} ber deren Methode
   * {@link ElementRegistrierung#registriereDeskriptorAktion(de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion)}
   * registriert.
   */
  public void earlyStartup()
  {
    IAction action = new Action() {
      public void run()
      {
        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
        IWorkbenchPage page = dw.getActivePage();

        try
        {
          page.showView("de.bsvrz.buv.plugin.bmvew.MeldungsanzeigeSicht");
        }
        catch (PartInitException e)
        {
          e.printStackTrace();
        }
      }
    };
    action.setText("Betriebsmeldungsverwaltung");
    action.setId("de.bsvrz.buv.plugin.bmvew.verwaltungsSicht");

    DeskriptorAktion deskriptorAktion = new DeskriptorAktion("de.bsvrz.buv.plugin.bmvew", action, false);

    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion);

  }

}
