package de.bsvrz.buv.plugin.bmvew;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSourceAdapter;
import org.eclipse.swt.dnd.DragSourceEvent;

import de.bsvrz.sys.funclib.debug.Debug;

public class ZugZuhoererMeldung extends DragSourceAdapter
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * Viewer, auf dem gearbeitet wird.
   */
  private TableViewer _tableViewer;

  /**
   * Liste von Systemobjekten
   */
  private List<Meldung> _listeDaten;

  /**
   * Hlt die Singleton-Instanz der Klasse SpeicherTransfer vor.
   */
  private SpeicherTransfer _speicherTransfer;

  /**
   * Konsturktor
   * 
   * @param listViewer
   * @param listeDaten
   */
  public ZugZuhoererMeldung(TableViewer tabelle, List<Meldung> listeDaten)
  {
    this._tableViewer = tabelle;
    this._listeDaten = listeDaten;
  }

  public void dragStart(DragSourceEvent event)
  {
    _debug.fine(getClass().getName() + "::dragStart => Start");

    event.doit = !_tableViewer.getSelection().isEmpty();
  }

  public void dragFinished(DragSourceEvent event)
  {
    if (!event.doit)
      return;
    // if the gadget was moved, remove it from the source viewer
    // if (event.detail == DND.DROP_MOVE) {
    // IStructuredSelection selection =
    // (IStructuredSelection)_viewer.getSelection();
    // for (Iterator it = selection.iterator(); it.hasNext();) {
    // //Entfernen der Elemente
    // }
    // _viewer.refresh();
    // }
    if (event.detail == DND.DROP_MOVE)
    {
      //System.out.println(getClass().getName() + " => Lschen.");
      // IStructuredSelection selection
      // =(IStructuredSelection)_viewer.getSelection();
      // Iterator und aktualisieren der Elemente
      _tableViewer.refresh();
    }

    _debug.fine(getClass().getName() + " => dragFinished");

  }

  public void dragSetData(DragSourceEvent event)
  {
    IStructuredSelection selection = (IStructuredSelection)_tableViewer.getSelection();

    // SpeicherDNDTransfer.getInstanz().setAltePosition(_tableViewer.getList().getSelectionIndex());

    Object selectedObject = selection.getFirstElement();

    _speicherTransfer = SpeicherTransfer.getInstanz();
    _speicherTransfer.setAltePosition(positionObjektInListe(selectedObject, _listeDaten));

    // Meldung?
    if (selectedObject instanceof Meldung)
    {
      Meldung meldung = (Meldung)selectedObject;
      _speicherTransfer.setMeldung(meldung);
      String daten = "[PID]" + meldung.getPid();
      event.data = daten;
    }

  }

	private int positionObjektInListe(Object object, List<Meldung> liste)
  {
    int i = -1;
    
    @SuppressWarnings("unchecked")
    Iterator it = liste.iterator();
    while (it.hasNext())
    {
      i++;
      if (it.next().equals(object))
      {
        break;
      }
    }

    return i;
  }

}
