package de.bsvrz.buv.plugin.sim;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;

/**
 * Nach Auswahl des Menpunkts "Simulation..." in der Rahmenapplikation muss sich der Verwaltungsdialog fr
 * SimulationsEintrge ffnen. In diesem Dialog sind die aktuell definierten Eintrge darzustellen. Fr jeden Eintrag
 * sind die Eigenschaften Name, die zugeteilte Simulationsvariante, die Simulationsstrecke, auf der sie basiert, der
 * Simulationstyp und der aktuelle Simulationszustand darzustellen.
 * 
 * <br>
 * <br>
 * 
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-1</li>
 * </ul>
 * 
 * @version $Revision: 1.2 $ / $Date: 2010/02/02 15:36:55 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class Verwaltungsdialog extends Dialog
{
  /**
   * Liste der Simulationen
   */
  private List<Simulation> _lSimulationen = new LinkedList<Simulation>();

  /**
   * DaV Verbindung
   */
  private DaVKommunikation daVKommunikation = null;

  /**
   * Konstruktor fr neue Instanzen der Klasse {@link Verwaltungsdialog}.
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public Verwaltungsdialog(Shell parent)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link Verwaltungsdialog}.
   * 
   */
  public void oeffne()
  {
    // Neue Shell anlegen, Wait & Dispose, evtl. Rckgabewerte.
  }

  /**
   * Generiert die Elemente des Dialogs {@link Verwaltungsdialog}.
   * 
   */
  private void generiereGui()
  {

  }

  /**
   * Generiert einen neuen Eintrag
   * 
   */
  private void eintragNeuGenerieren()
  {

  }

  /**
   * Kopiert einen Eintrag. Der Name des Eintrags wird um den Prfix "Kopie von" erweitert. Es ffnet sich danach der
   * Definitionsdialog zur nderung des kopierten Eintrags.
   * 
   */
  private void eintragKopieren()
  {

  }

  /**
   * Lscht einen Eintrag. Mit Sicherheitsabfrage. Nur aktivierbar, wenn eine Simulation ausgewhlt ist und diese sich
   * im Zustand "gestoppt" befindet.
   * 
   */
  private void eintragLoeschen()
  {

  }

  /**
   * Startet die Simulation. Whrend des Vorstarts wird ein entsprechender (nicht modaler) Info-Dialog angezeigt, bis
   * der jeweilige Dialog {@link Simulationssteuerung} zur Steuerung der Simulation geffnet wurde.
   * 
   * <br>
   * 
   * Wird eine bereits gestartete Simulation selektiert, so ist Buttontext "Start" gegen "Simulationssteuereung"
   * auszutauschen. Beim Drcken wird dann das Simulationssteuerungsfenster angezeigt.
   * 
   */
  private void simulationStart()
  {

  }

  /**
   * Stopt eine laufende Simulation. Luft eine ausgewhlte Simulation nicht, ist dieser Button ausgegraut.
   * 
   */
  private void simulationStop()
  {

  }

  /**
   * Schliet den Dialog {@link Verwaltungsdialog}.
   * 
   */
  private void aktionSchliessen()
  {

  }

  /**
   * Zeigt die Hilfe zum Dialog {@link Verwaltungsdialog} an.
   * 
   */
  private void aktionHilfe()
  {
  }

  /**
   * Kapselt die Darstellung der Simulation sowie der zugehrigen Simulationssteuerung.
   * 
   * @author HofmannJ
   */
  private class SimulationDarstellung
  {
    protected Simulation _simulation = null;

    protected Simulationssteuerung _simulationssteuerung = null;

    /**
     * Konstruktor.
     * 
     * @param simulation
     *          Simulation.
     */
    public SimulationDarstellung(Simulation simulation)
    {
      this._simulation = simulation;
    }
  }

}
