package de.bsvrz.buv.plugin.syskal;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;

import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;

/**
 * ber den Definitionsdialog muss ein Systemkalendereintrag neu angelegt bzw ein existierender Eintrag gendert werden
 * knnen.
 * 
 * <br>
 * <br>
 * 
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-5</li>
 * </ul>
 * 
 * @version $Revision: 1.1 $ / $Date: 2010/02/02 15:22:19 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class Definitionsdialog extends Dialog
{
  Eintrag _systemkalenderDatensatz = null;

  /**
   * Begin: Erfassen von Datum + Uhrzeit
   */
  private DatumZeit _datumZeitBegin = null;

  /**
   * Begin: Erfassen von Datum + Uhrzeit
   */
  private DatumZeit _datumZeitEnde = null;

  /**
   * Konstruktor fr neue Instanzen der Klasse {@link Definitionsdialog}.
   * 
   * @param parent
   *          Parent-Shell, die fr die Darstellung benutzt werden soll.
   */
  public Definitionsdialog(Shell parent)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link Definitionsdialog}.
   * 
   * @return Liefert <code>true</code>, wenn ein neuer SystemkalenderEintrag erstellt werden konnte, sonst
   *         <code>false</code>.<br>
   *         Wenn <code>true</code> geliefert wurde, kann dies die Klasse {@link VerwaltungsSicht} auswerten und die
   *         dargestellte Liste aktuallisieren.
   * 
   */
  public boolean oeffne()
  {
    // Neue Shell anlegen, Wait & Dispose, evtl. Rckgabewerte.
    _systemkalenderDatensatz = new Eintrag();
    return false;
  }

  /**
   * ffnet den Dialog {@link Definitionsdialog} zur Berarbeitung eines vorhandenen Systemkalendereintrags.
   * 
   * @param systemkalenderDatensatz
   *          Systemkalendereintrag, der bearbeitet werden soll.
   * 
   * @return Liefert <code>true</code>, wenn der SystemkalenderEintrag bearbeitet werden konnte, sonst
   *         <code>false</code>. <br>
   *         Wenn <code>true</code> geliefert wurde, kann dies die Klasse {@link VerwaltungsSicht} auswerten und die
   *         dargestellte Liste aktualisieren.
   */
  public boolean oeffne(Eintrag systemkalenderDatensatz)
  {
    // Neue Shell anlegen, Wait & Dispose, evtl. Rckgabewerte.
    this._systemkalenderDatensatz = systemkalenderDatensatz;
    return false;
  }

  /**
   * Generiert die Elemente des Dialogs {@link Definitionsdialog}.
   * 
   */
  private void generiereGui()
  {

  }

  /**
   * bernimmt die aktuellen Einstellungen. <br>
   * Dabei wird geprft: <br>
   * <ul>
   * <li>ist der eingegebene Zeitbereich gltig?</li>
   * <li>wurde ein Name eingegeben?</li>
   * </ul>
   * <br>
   * Scheitert diese Prfung, wird eine Fehlermeldung ausgegeben.
   */
  private void aktionOk()
  {

  }

  /**
   * Dialog wird ohne bernahme der Einstellungen geschlossen.
   * 
   */
  private void aktionAbbrechen()
  {

  }

  /**
   * ffnet die Hilfe zum Dialog {@link Definitionsdialog}.
   * 
   */
  private void aktionHilfe()
  {

  }

}
