package de.bsvrz.buv.rw.basislib.berechtigung;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.eclipse.swt.widgets.Display;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.bsvrz.buv.rw.basislib.Defs;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.buv.rw.rw.dav.datenbasis.prelader.DaVPreLader;
import de.bsvrz.buv.rw.rw.kommandozeilenparameter.KmdParameter;
import de.bsvrz.buv.rw.rw.kommandozeilenparameter.Kommandozeilenparameter;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.vewdynobj.VerwaltungDynObj;

public class OberflaechenBerechtigungTest3
{

  /**
   * Klasse zur Verwaltung der Verbindung mit dem DaV
   */
  private static DaVVerbindung _daVVerbindung = null;

  /**
   * Verbindung mit dem DaV
   */
  private static ClientDavInterface _connection = null;

  private static IOberflaechenBerechtigungZuhoerer _zuhoerer = null;

  private static HashMap<String, String> _resultMap = new HashMap<String, String>();

  private static OberflaechenFunktion f1;

  private static OberflaechenFunktion f2;

  private static OberflaechenFunktion f3;

  private static OberflaechenFunktion f4;

  private static OberflaechenFunktion f5;

  private static DaVPreLader _preLader;


  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
    _daVVerbindung = DaVVerbindung.getInstanz();

    Warten warten = new Warten();
    warten.warte(3000);

    System.out.println("===OberflaechenBerechtigungTest3 - Start===");

    _daVVerbindung.setDaVBenutzer("Tester");
    _daVVerbindung.setDaVPasswort("geheim");
    _daVVerbindung.setDaVIp("localhost");
    _daVVerbindung.setDaVPort(8083);

    KmdParameter kmdParameter1 = new KmdParameter("-berechtigungsKonzept", "true");
    Kommandozeilenparameter.getInstanz().setKommandoZeilenParameter(kmdParameter1);

    KmdParameter kmdParameter2 = new KmdParameter("-oberflaechenObjekt", Defs.PID_AOE);
    Kommandozeilenparameter.getInstanz().setKommandoZeilenParameter(kmdParameter2);

    KmdParameter kmdParameter3 = new KmdParameter("-davSystemObjekteVorladen", "true");
    Kommandozeilenparameter.getInstanz().setKommandoZeilenParameter(kmdParameter3);

    boolean baueVerbindungMitDaVAuf = _daVVerbindung.baueVerbindungMitDaVAuf();
    if (baueVerbindungMitDaVAuf)
    {
      System.out.println("DaV-Verbindung aktiv: " + _daVVerbindung.istDaVVerbindungAktiv());
      _connection = DaVKommunikation.getInstanz().getConnection();

      System.out.println("Beginn Initiales Laden SystemObjekte");

      _preLader = DaVPreLader.getInstanz();
      
      while(!_preLader.istInitialesLadenAbgeschlossen()){
        
      }
      
      System.out.println("Initiales Laden SystemObjekte abgeschlossen");


      f1 = new OberflaechenFunktion("SichtObjektzusammenstellungOk", _zuhoerer, "Aktionen", "Ok");
      f2 = new OberflaechenFunktion("SichtObjektzusammenstellungAbbrechen", _zuhoerer, "Aktionen", "Abbrechen");
      f3 = new OberflaechenFunktion("SichtObjektzusammenstellungHilfe", _zuhoerer, "Aktionen", "Hilfe");
      f4 = new OberflaechenFunktion("SichtObjektzusammenstellungHinzufuegen", _zuhoerer, "Aktionen", "Hinzufuegen");
      f5 = new OberflaechenFunktion("SichtObjektzusammenstellungLoeschen", _zuhoerer, "Aktionen", "Loeschen");
      OberflaechenBerechtigung.getInstanz().hinzufuegenOberflaechenFunktion(f1);
      OberflaechenBerechtigung.getInstanz().hinzufuegenOberflaechenFunktion(f2);
      OberflaechenBerechtigung.getInstanz().hinzufuegenOberflaechenFunktion(f3);
      OberflaechenBerechtigung.getInstanz().hinzufuegenOberflaechenFunktion(f4);
      OberflaechenBerechtigung.getInstanz().hinzufuegenOberflaechenFunktion(f5);

      _zuhoerer = new IOberflaechenBerechtigungZuhoerer() {

        @Override
        public void freigabe(OberflaechenBerechtigungEreignis e)
        {
          // System.out.println("Info Freigabe erhalten: " + e.hatFreigabe());

          List<SystemObject> liste1 = e.getSystemObjekteFreigabe();
          List<SystemObject> liste2 = e.getSystemObjekteSperrung();
          for (SystemObject so : liste1)
          {
            System.out.println("Objekte Freigabe: " + so);
          }
          for (SystemObject so : liste2)
          {
            System.out.println("Objekte Sperrung: " + so);
          }

          List<OberflaechenFunktion> liste3 = e.getOberflaechenFunktionFreigabe();
          List<OberflaechenFunktion> liste4 = e.getOberflaechenFunktionSperrung();
          for (OberflaechenFunktion of : liste3)
          {
            System.out.println("Funktion Freigabe: " + of.getFunktionsName());
            // Object object = _oberflaechenElemente.get(of.getFunktionsName());
            //
            // if (object instanceof Button)
            // {
            // Button button = (Button) object;
            // button.setEnabled(true);
            //
            // }
            synchronized (_resultMap)
            {
              _resultMap.put(of.getFunktionsName(), "true");
            }

          }
          for (OberflaechenFunktion of : liste4)
          {
            System.out.println("Funktion Sperrung: " + of.getFunktionsName());
          }

        }

        @Override
        public void sperrung(OberflaechenBerechtigungEreignis e)
        {
          // System.out.println("Info Sperrung erhalten: " + e.hatFreigabe());

          List<SystemObject> liste1 = e.getSystemObjekteFreigabe();
          List<SystemObject> liste2 = e.getSystemObjekteSperrung();
          for (SystemObject so : liste1)
          {
            System.out.println("Objekte Freigabe: " + so);
          }
          for (SystemObject so : liste2)
          {
            System.out.println("Objekte Sperrung: " + so);
          }

          List<OberflaechenFunktion> liste3 = e.getOberflaechenFunktionFreigabe();
          List<OberflaechenFunktion> liste4 = e.getOberflaechenFunktionSperrung();
          for (OberflaechenFunktion of : liste3)
          {
            System.out.println("Funktion Freigabe: " + of.getFunktionsName());
          }
          for (OberflaechenFunktion of : liste4)
          {
            System.out.println("Funktion Sperrung: " + of.getFunktionsName());
            // Object object = _oberflaechenElemente.get(of.getFunktionsName());
            //
            // if (object instanceof Button)
            // {
            // Button button = (Button) object;
            // button.setEnabled(false);
            //
            // }
            synchronized (_resultMap)
            {
              _resultMap.put(of.getFunktionsName(), "false");
            }

          }

        }
      };

      DaVKommunikation.getInstanz().hinzufuegenOberflaechenBenutzerZuhoerer(_zuhoerer);
   
    }
    else
    {
      fail("Keine DaV-Verbindung");
    }

  }

  @AfterClass
  public static void tearDownAfterClass() throws Exception
  {
    OberflaechenBerechtigung.getInstanz().entferneOberflaechenFunktion(f1);
    OberflaechenBerechtigung.getInstanz().entferneOberflaechenFunktion(f2);
    OberflaechenBerechtigung.getInstanz().entferneOberflaechenFunktion(f3);
    OberflaechenBerechtigung.getInstanz().entferneOberflaechenFunktion(f4);
    OberflaechenBerechtigung.getInstanz().entferneOberflaechenFunktion(f5);

    DaVKommunikation.getInstanz().entferneOberflaechenBenutzerZuhoerer(_zuhoerer);

    while (!_daVVerbindung.trenneDaVVerbindungSWTThreadsicher())
    {

    }

    System.out.println("===OberflaechenBerechtigungTest3 - Ende ===");
  }

  @Before
  public void setUp() throws Exception
  {
  }

  @After
  public void tearDown() throws Exception
  {
  }

  private void parametriere()
  {

    AttributeGroup atg = _connection.getDataModel().getAttributeGroup("atg.oberflchenBerechtigung");

    Data data = _connection.createData(atg);
    Array array = data.getItem("OberflchenBerechtigung").asArray();
    array.setLength(6);

    Data d0 = array.getItem(0);
    Array array2 = d0.getItem("Berechtigungsklasse").asArray();
    array2.setLength(1);
    array2.getItem(0).asTextValue().setText("*");
    Array array3 = d0.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("*");
    d0.getItem("Berechtigung").asTextValue().setText("Sperrung");
    Array array4 = d0.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d0.getItem("AusnahmeDefinition").asTextValue().setText("1");
    d0.getItem("Ebene").asTextValue().setText("0");

    Data d1 = array.getItem(1);
    array2 = d1.getItem("Berechtigungsklasse").asArray();
    array2.setLength(2);
    array2.getItem(0).asTextValue().setText("berechtigungsklasse.keinZugriff");
    array2.getItem(1).asTextValue().setText("berechtigungsklasse.operator");
    array3 = d1.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("SichtObjektzusammenstellungOk");
    d1.getItem("Berechtigung").asTextValue().setText("Freigabe");
    array4 = d1.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d1.getItem("AusnahmeDefinition").asTextValue().setText("2");
    d1.getItem("Ebene").asTextValue().setText("1");

    Data d2 = array.getItem(2);
    array2 = d2.getItem("Berechtigungsklasse").asArray();
    array2.setLength(1);
    array2.getItem(0).asTextValue().setText("berechtigungsklasse.keinZugriff");
    array3 = d2.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("SichtObjektzusammenstellungAbbrechen");
    d2.getItem("Berechtigung").asTextValue().setText("Freigabe");
    array4 = d2.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d2.getItem("AusnahmeDefinition").asTextValue().setText("3");
    d2.getItem("Ebene").asTextValue().setText("1");

    Data d3 = array.getItem(3);
    array2 = d3.getItem("Berechtigungsklasse").asArray();
    array2.setLength(1);
    array2.getItem(0).asTextValue().setText("berechtigungsklasse.operator");
    array3 = d3.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("SichtObjektzusammenstellungAbbrechen");
    d3.getItem("Berechtigung").asTextValue().setText("Sperrung");
    array4 = d3.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d3.getItem("AusnahmeDefinition").asTextValue().setText("4");
    d3.getItem("Ebene").asTextValue().setText("1");

    Data d4 = array.getItem(4);
    array2 = d4.getItem("Berechtigungsklasse").asArray();
    array2.setLength(1);
    array2.getItem(0).asTextValue().setText("berechtigungsklasse.keinZugriff");
    array3 = d4.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("SichtObjektzusammenstellungHilfe");
    d4.getItem("Berechtigung").asTextValue().setText("Sperrung");
    array4 = d4.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d4.getItem("AusnahmeDefinition").asTextValue().setText("5");
    d4.getItem("Ebene").asTextValue().setText("1");

    Data d5 = array.getItem(5);
    array2 = d5.getItem("Berechtigungsklasse").asArray();
    array2.setLength(1);
    array2.getItem(0).asTextValue().setText("berechtigungsklasse.operator");
    array3 = d5.getItem("Funktion").asArray();
    array3.setLength(1);
    array3.getItem(0).asTextValue().setText("SichtObjektzusammenstellungHilfe");
    d5.getItem("Berechtigung").asTextValue().setText("Freigabe");
    array4 = d5.getItem("ObjektMenge").asArray();
    array4.setLength(1);
    array4.getItem(0).asTextValue().setText("*");
    d5.getItem("AusnahmeDefinition").asTextValue().setText("0");
    d5.getItem("Ebene").asTextValue().setText("1");

    parametriereObjekt(Defs.PID_AOE, atg, data);

    try
    {
      Thread.sleep(3000);
    }
    catch (InterruptedException e)
    {
      e.printStackTrace();
    }

    atg = _connection.getDataModel().getAttributeGroup("atg.benutzerParameter");
    data = _connection.createData(atg);

    SystemObject so1 = _connection.getDataModel().getObject("berechtigungsklasse.keinZugriff");
    data.getItem("berechtigungsklasse").asReferenceValue().setSystemObject(so1);

    parametriereObjekt("benutzer.tester", atg, data);

    try
    {
      Thread.sleep(3000);
    }
    catch (InterruptedException e)
    {
      e.printStackTrace();
    }

    atg = _connection.getDataModel().getAttributeGroup("atg.benutzerParameter");
    data = _connection.createData(atg);
    SystemObject so2 = _connection.getDataModel().getObject("berechtigungsklasse.operator");
    data.getItem("berechtigungsklasse").asReferenceValue().setSystemObject(so2);

    parametriereObjekt("benutzer.testDatenverteiler", atg, data);

    try
    {
      Thread.sleep(3000);
    }
    catch (InterruptedException e)
    {
      e.printStackTrace();
    }

  }
 
  @Test
  public void systemTest()
  {

    parametriere();

    synchronized (_resultMap)
    {
      _resultMap.clear();
    }

    OberflaechenBerechtigung.setDaV(DaVKommunikation.getInstanz());
    final OberflaechenBerechtigung instanz = OberflaechenBerechtigung.getInstanz();

    final List<OberflaechenFunktion> funktionen = instanz.getFunktionen();

    final List<SystemObject> systemObjekte = new ArrayList<SystemObject>();
    systemObjekte.add(_connection.getDataModel().getObject("fs.mq.a10.0000.1fs"));

    Display.getDefault().syncExec(new Runnable() {
      public void run()
      {
        for (OberflaechenFunktion of : funktionen)
        {
          instanz.pruefeBerechtigungElement(systemObjekte, of.getFunktionsName());
        }
      }
    });

    // for (Map.Entry<String, String> me : _resultMap.entrySet())
    // {
    // System.out.println(me.getKey() + " : " + me.getValue());
    // }

    synchronized (_resultMap)
    {

      if (_resultMap.containsKey("SichtObjektzusammenstellungOk"))
      {
        assertEquals("Test 1", "true", _resultMap.get("SichtObjektzusammenstellungOk"));
      }
      else
        fail("Test 1");

      if (_resultMap.containsKey("SichtObjektzusammenstellungAbbrechen"))
      {
        assertEquals("Test 2", "true", _resultMap.get("SichtObjektzusammenstellungAbbrechen"));
      }
      else
        fail("Test 2");

      if (_resultMap.containsKey("SichtObjektzusammenstellungHilfe"))
      {
        assertEquals("Test 3", "false", _resultMap.get("SichtObjektzusammenstellungHilfe"));
      }
      else
        fail("Test 3");

      if (_resultMap.containsKey("SichtObjektzusammenstellungHinzufuegen"))
      {
        assertEquals("Test 4", "false", _resultMap.get("SichtObjektzusammenstellungHinzufuegen"));
      }
      else
        fail("Test 4");

      if (_resultMap.containsKey("SichtObjektzusammenstellungLoeschen"))
      {
        assertEquals("Test 5", "false", _resultMap.get("SichtObjektzusammenstellungLoeschen"));
      }
      else
        fail("Test 5");

    }

    // _daVVerbindung.trenneAlleVerbindungenSWTThreadsicher();

  }

  private void parametriereObjekt(String pid, AttributeGroup atg, Data parameter)
  {

    // Erzeuge Parameter
    Aspect asp = _connection.getDataModel().getAspect("asp.parameterVorgabe");
    VerwaltungDynObj vewParam = new VerwaltungDynObj(_connection, _connection.getDataModel(), null, null, null, atg,
        asp);

    Data[] datas = new Data[1];
    datas[0] = parameter;
    vewParam.setDynamicObject(_connection.getDataModel().getObject(pid));
    vewParam.parametriere(datas);
  }

  /**
   * Thread-Klasse, liefert einen Befehl <code>warten</code>, mit dessen Hilfe die Ausfhrung des JUnit-Testes
   * pausiert werden kann.
   * 
   * @author HofmannJ
   * 
   */
  private static class Warten implements Runnable
  {
    private boolean _laufeThread = false;

    private Long _warteZeit = new Long(1000);

    public Warten()
    {
    }

    /**
     * Veranlasst das Programm dazu, eine bestimmte Zeit lang zu warten.
     * 
     * @param warteZeit
     *          Wartezeit in Millisekunden.
     */
    public void warte(long warteZeit)
    {
      synchronized (_warteZeit)
      {
        _warteZeit = warteZeit;
      }

      startThread();
      synchronized (this)
      {
        try
        {
          wait();
        }
        catch (InterruptedException e)
        {
          e.printStackTrace();
        }
      }
    }

    private void startThread()
    {
      if (!_laufeThread)
      {
        Thread th = new Thread(this);
        th.setName("Warten...");
        _laufeThread = true;
        th.start();
      }
    }

    @Override
    public void run()
    {
      if (_laufeThread)
      {
        try
        {
          Thread.sleep(_warteZeit);
        }
        catch (InterruptedException e)
        {
          e.printStackTrace();
        }
        finally
        {
          synchronized (this)
          {
            notifyAll();
          }
        }
      }

      _laufeThread = false;
    }

  }

}
