/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.einstellungen;

import org.eclipse.core.resources.ISaveParticipant;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.IStartup;

import de.bsvrz.buv.rw.basislib.Activator;

/**
 * Diese Klasse bernimmt setzt die Preferences fr dieses Modul.
 * 
 * @author HofmannJ
 * 
 */
public class EinstellungenStart implements IStartup
{
//  /**
//   * PreferenceStore
//   */
//  private IPreferenceStore _praeferenzen = null;

  public void earlyStartup()
  {
    init();
  }

  private void init()
  {
//    _praeferenzen = PlatformUI.getPreferenceStore();

//    Location installLocation = Platform.getInstallLocation();
//    String heimatPfad = installLocation.getURL().getPath();
//
//    heimatPfad = heimatPfad.substring(1);
//
//    // Verzeichnis fr Voreinstellungen setzen
//    String einstellungenPfad = heimatPfad + "einstellungen" + "/";
//    _praeferenzen.setDefault(EinstellungenBezeichner.psPfadEinstellungen, einstellungenPfad);
//    _debug.fine("EinstellungenPfad: " + einstellungenPfad);
//
//    EinstellungenWaehler.getInstanz();

    sichereArbeitsbereich();

  }

  /**
   * Registriert alle Klassen dieses Plug-Ins, die das Interface {@link ISaveParticipant} implementieren.
   * 
   */
  private void sichereArbeitsbereich()
  {
    ArbeitsbereichsSpeicherungEinstellungen asv = new ArbeitsbereichsSpeicherungEinstellungen();

    // Fr die Voreinstellungen
    try
    {
      ResourcesPlugin.getWorkspace().addSaveParticipant(Activator.getDefault(), asv);
    }
    catch (CoreException e)
    {
      e.printStackTrace();
    }
  }
}
