/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.listendarstellung;

import java.util.LinkedList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;

import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.kupzog.ktable.KTable;
import de.kupzog.ktable.KTableCellSelectionListener;

public class TestKTableAenderungsDarstellung
{

	private Shell _shell = null;

	private Group groupOben = null;

	private Composite compositeUnten = null;

	private Composite compositeUntenRechts = null;

	private Button buttonOk = null;

	private Button buttonAbbrechen = null;

	private DaVComListendarstellungstest _dav = null;

	private DavEmpfangenSendenAenderungsDarstellung _davEmpfangAenderung = null;

	// private String typ = "typ.messQuerschnitt";
	// private String atg = "atg.anteilLkwFuzzy";
	// private String asp = "asp.parameterDefault";

	// private String typ = "typ.autarkeOrganisationsEinheit";
	// private String atg = "atg.benutzerEinstellungenOberflcheNetzweit";
	// private String asp = "asp.parameterSoll";

	private String typ = "typ.autarkeOrganisationsEinheit";
	private String pidSystemObject = "kv.testKonfiguration";
	private String atg = "atg.oberflchenBerechtigung";
	// private String asp = "asp.parameterSoll";
	private String asp = "asp.parameterIst";

	/**
	 * Tabelle
	 */
	private KTable _kTable = null;

	private TabellenModell _tabellenModell;

	public TestKTableAenderungsDarstellung()
	{
		_dav = new DaVComListendarstellungstest();
		_dav.baueVerbindungMitDaVAuf();
	}

	/**
	 * This method initializes groupOben
	 * 
	 */
	private void createGroupOben()
	{
		GridData gridDataObenInhalt = new GridData();
		gridDataObenInhalt.horizontalAlignment = GridData.FILL;
		gridDataObenInhalt.grabExcessHorizontalSpace = true;
		gridDataObenInhalt.grabExcessVerticalSpace = true;
		gridDataObenInhalt.verticalAlignment = GridData.FILL;
		GridData gridDataOben = new GridData();
		gridDataOben.grabExcessHorizontalSpace = true;
		gridDataOben.verticalAlignment = GridData.FILL;
		gridDataOben.grabExcessVerticalSpace = true;
		gridDataOben.horizontalAlignment = GridData.FILL;
		groupOben = new Group(_shell, SWT.NONE);
		groupOben.setLayout(new GridLayout());
		groupOben.setLayoutData(gridDataOben);
		groupOben.setText("Tabelle:");

		_kTable = new KTable(groupOben, SWT.V_SCROLL | SWT.H_SCROLL
				| SWT.HIDE_SELECTION);
		_kTable.setLayoutData(gridDataObenInhalt);

		// ScrolledComposite scp = new ScrolledComposite(groupOben, SWT.BORDER |
		// SWT.V_SCROLL | SWT.H_SCROLL);
		// scp.setLayout(new GridLayout());
		// scp.setLayoutData(gridDataObenInhalt);
		//		
		//		
		// KTable sTable = new KTable(scp, SWT.HIDE_SELECTION);
		// GridData gridDataTabelle = new GridData();
		// gridDataTabelle.horizontalAlignment = GridData.FILL;
		// gridDataTabelle.grabExcessHorizontalSpace = true;
		// gridDataTabelle.grabExcessVerticalSpace = true;
		// gridDataTabelle.verticalAlignment = GridData.FILL;//
		// sTable.setLayoutData(gridDataTabelle);

		// sTable.setModel(new SpanModelExample());

		LinkedList<DataTableObjectErweitert> dtos = new LinkedList<DataTableObjectErweitert>();

		_tabellenModell = new TabellenModell(_dav.getVerbindung(), typ, atg, asp,
				dtos);

		_tabellenModell
				.setDarstellungsArt(EnumDarstellungsArt.aenderungsDarstellung);

		_kTable.setModel(_tabellenModell);

		/*
		 * Spalten der Tabelle auf die optimale Breite bringen
		 */
		int anzSpalten = _kTable.getModel().getColumnCount();
		for (int i = 0; i < anzSpalten; i++)
		{
			_kTable.resizeColumnOptimal(i);
		}

		_kTable.addCellSelectionListener(new KTableCellSelectionListener()
		{
			public void cellSelected(int col, int row, int statemask)
			{
				System.out.println("Cell [" + col + ";" + row + "] selected.");
			}

			public void fixedCellSelected(int col, int row, int statemask)
			{
				System.out.println("Header [" + col + ";" + row + "] selected.");
			}

		});
		//	
		// sTable.addCellResizeListener(
		// new KTableCellResizeListener()
		// {
		// public void columnResized(int col, int newWidth) {
		// System.out.println("Column "+col+" resized to "+newWidth);
		// }
		// public void rowResized(int row, int newHeight) {
		// System.out.println("Row "+row+" resized to "+newHeight);
		// }
		// }
		// );
	}

	/**
	 * This method initializes compositeUnten
	 * 
	 */
	private void createCompositeUnten()
	{
		GridData gridDataUnten = new GridData();
		gridDataUnten.grabExcessHorizontalSpace = true;
		gridDataUnten.verticalAlignment = GridData.CENTER;
		gridDataUnten.horizontalAlignment = GridData.FILL;
		compositeUnten = new Composite(_shell, SWT.NONE);
		compositeUnten.setLayout(new GridLayout());
		createCompositeUntenRechts();
		compositeUnten.setLayoutData(gridDataUnten);
	}

	/**
	 * Schliet die Shell.
	 */
	private void aktionSchliessen()
	{
		if (_davEmpfangAenderung != null)
		{
			_davEmpfangAenderung.abmeldenEmpfang(pidSystemObject, atg, asp);
		}
		_dav.trenneDaVVerbindung();
		_shell.dispose();
	}

	private void aktionAktualisieren()
	{
		_kTable.redraw();
	}

	/**
	 * This method initializes compositeUntenRechts
	 * 
	 */
	private void createCompositeUntenRechts()
	{
		GridData gridDataUntenRechts = new GridData();
		gridDataUntenRechts.horizontalAlignment = GridData.END;
		gridDataUntenRechts.grabExcessHorizontalSpace = true;
		gridDataUntenRechts.verticalAlignment = GridData.CENTER;
		RowLayout rowLayout = new RowLayout();
		rowLayout.pack = false;
		compositeUntenRechts = new Composite(compositeUnten, SWT.NONE);
		compositeUntenRechts.setLayout(rowLayout);
		compositeUntenRechts.setLayoutData(gridDataUntenRechts);
		buttonOk = new Button(compositeUntenRechts, SWT.NONE);
		buttonOk.setText("OK");
		buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSchliessen();
			}
		});

		buttonAbbrechen = new Button(compositeUntenRechts, SWT.NONE);
		buttonAbbrechen.setText("Abbrechen");
		buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				// aktionSchliessen();
				aktionAktualisieren();
			}
		});
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		/*
		 * Before this is run, be sure to set up the launch configuration
		 * (Arguments->VM Arguments) for the correct SWT library path in order to
		 * run with the SWT dlls. The dlls are located in the SWT plugin jar. For
		 * example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 * installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		TestKTableAenderungsDarstellung thisClass = new TestKTableAenderungsDarstellung();
		thisClass.createShell();
		thisClass._shell.open();

		while (!thisClass._shell.isDisposed())
		{
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	protected void anmeldenTabelleZumEmpfang()
	{
		if (_davEmpfangAenderung == null)
		{
			if (_dav != null)
			{
				if (_dav.getVerbindung() != null)
				{
					_davEmpfangAenderung = new DavEmpfangenSendenAenderungsDarstellung(
							(ClientDavConnection) _dav.getVerbindung());

					_davEmpfangAenderung.setDisplay(Display.getDefault());
				}
			}
		}

		if (_davEmpfangAenderung != null)
		{
			_davEmpfangAenderung.setKTable(_kTable);
			_davEmpfangAenderung.setTabellenModell(_tabellenModell);

			_davEmpfangAenderung.anmeldenEmpfang(pidSystemObject, atg, asp);
		}
	}

	public boolean open()
	{
		boolean re = false;

		Display display = Display.getDefault();
		TestKTableAenderungsDarstellung thisClass = new TestKTableAenderungsDarstellung();
		thisClass.createShell();
		thisClass._shell.open();

		while (!thisClass._shell.isDisposed())
		{
			if (!display.readAndDispatch())
				display.sleep();
		}
		// display.dispose();
		re = true;
		return re;

	}

	/**
	 * This method initializes sShell
	 */
	private void createShell()
	{
		_shell = new Shell();
		_shell.setText("Test KTable");
		createGroupOben();
		createCompositeUnten();
		_shell.setLayout(new GridLayout());
		_shell.setSize(800, 600);

		/*
		 * Anmeldung zum Empfang
		 */
		anmeldenTabelleZumEmpfang();
	}

}
