/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.listendarstellung;

import java.util.Iterator;
import java.util.LinkedList;

public class TestKnoten
{

  /**
   * @param args
   */
  public static void main(String[] args)
  {
    Knoten knotenA = new Knoten("A");
    Knoten knotenB = new Knoten("B");
    Knoten knotenC = new Knoten("C");
    Knoten knotenD = new Knoten("D");

    knotenA.addNachfolger(knotenB);
    knotenB.addNachfolger(knotenC);
    knotenC.addNachfolger(knotenD);

    int tiefe = knotenD.getTiefe();
    System.out.println("Tiefe von Knoten D: " + tiefe);

    System.out.println("Tiefe von Knoten C: " + knotenC.getTiefe());

    LinkedList<Knoten> pfadKnotenD = knotenD.getPfad();
    System.out.println("Pfadlnge des Knotens D: " + pfadKnotenD.size());
    Iterator<Knoten> it = pfadKnotenD.iterator();
    while (it.hasNext())
    {
      Knoten knoten = it.next();
      System.out.println("K: " + knoten.toString());
    }

    Knoten knotenA1 = new Knoten("A1");
    Knoten knotenA2 = new Knoten("A2");
    Knoten knotenA3 = new Knoten("A3");
    Knoten knotenA4 = new Knoten("A4");

    knotenA.addNachfolger(knotenA1);
    knotenA1.addNachfolger(knotenA2);
    knotenA2.addNachfolger(knotenA3);
    knotenA3.addNachfolger(knotenA4);

    Knoten knotenA1A = new Knoten("A1A");
    knotenA1.addNachfolger(knotenA1A);

    Knoten knotenB1 = new Knoten("B1");
    knotenB.addNachfolger(knotenB1);

    LinkedList<Knoten> knotenAufEbene = knotenA.bestimmeKnotenAufEbene(2);
    System.out.println("Size: " + knotenAufEbene.size());

    Iterator<Knoten> itGleicheEbene = knotenAufEbene.iterator();
    while (itGleicheEbene.hasNext())
    {
      Knoten ebenenKnoten = itGleicheEbene.next();
      System.out.println("Ebenenknoten: " + ebenenKnoten.toString());
    }

    System.out.println("Tiefe: " + knotenB.bestimmeTiefsteEbene());

  }

}
