/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.deskriptoren.zugriff;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.TransferData;

import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion;
import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorElement;
import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorPlugin;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * 
 * @author HofmannJ
 * @deprecated Wird nicht mehr verwendet!
 */
public class BaumFallAdapterDeskriptorElement extends ViewerDropAdapter
{

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  protected BaumFallAdapterDeskriptorElement(TreeViewer viewer)
  {
    super(viewer);
  }

  @Override
  public boolean performDrop(Object data)
  {
    _debug.fine(getClass().getName() + " ==> performDrop <==");

    // DescriptorElement target = (DescriptorElement)getCurrentTarget();
    Object target = getCurrentTarget();

    if (target == null)
    {
      _debug.fine("Target == null");
      // target = (DescriptorElement) getViewer().getInput();//
      target = getViewer().getInput();
    }

    DeskriptorElement[] toDrop = (DeskriptorElement[])data;
    TreeViewer viewer = (TreeViewer)getViewer();

    for (int i = 0; i < toDrop.length; i++)
    {
      if (toDrop[i].equals(target))
      {
        _debug.fine("Zu droppendes Element == Zielelement.");
        return false;
      }
    }

    for (int i = 0; i < toDrop.length; i++)
    {
      _debug.fine(getClass().getName() + "#" + i + " performDrop ID: " + toDrop[i].getAktionID() + " PluginId: "
          + toDrop[i].getPluginID());
      viewer.add(target, toDrop[i]);
      viewer.reveal(toDrop[i]);
    }

    _debug.fine("OK!");

    return true;
  }

  @Override
  public boolean validateDrop(Object target, int operation, TransferData transferType)
  {
    _debug.fine(getClass().getName() + " => validateDrop auf Target: " + target.getClass().getName());
    // if(target instanceof DescriptorPlugin &&
    // TransferDescriptorElement.getInstanz().isSupportedType(transferType))
    // {
    // return true;
    // }
    // else
    // {
    // return false;
    // }

    // if(TransferDescriptorElement.getInstanz().isSupportedType(transferType))
    if (target instanceof DeskriptorPlugin && TransferDeskriptorElement.getInstanz().isSupportedType(transferType))
    {
      _debug.fine(getClass().getName() + " => Untersttzter Transfer Typ auf DescriptorPlugin.");
      return true;
    }
    else if (target instanceof DeskriptorElement
        && TransferDeskriptorElement.getInstanz().isSupportedType(transferType))
    {
      _debug.fine(getClass().getName() + " => Untersttzter Transfer Typ auf DescriptorElement.");
      return true;
    }
    else if (target instanceof DeskriptorAktion && TransferDeskriptorElement.getInstanz().isSupportedType(transferType))
    {
      _debug.fine(getClass().getName() + " => Untersttzter Transfer Typ DescriptorAction.");
      return true;
    }
    else if (target == null)
    {
      _debug.fine(getClass().getName() + " => Target == NULL");
      return true;
    }
    else
    {
      _debug.fine(getClass().getName() + " => NICHT untersttzter Transfer Typ.");
      return false;
    }
  }

}
