/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.WorkbenchException;

import de.bsvrz.buv.rw.rw.menu.xml.datenstruktur.MenuSymbolLeisteDaten;
import de.bsvrz.buv.rw.rw.menu.xml.datenstruktur.MenuSymbolLeisteDaten.enumLeistenArt;
import de.bsvrz.sys.funclib.debug.Debug;

public class ActionEditor implements IWorkbenchWindowActionDelegate
{

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  @Override
  public void dispose()
  {
  }

  @Override
  public void init(IWorkbenchWindow window)
  {
  }

  @Override
  public void run(IAction action)
  {
    /*
     * Perspective ffnen
     */
    String perspectiveID = "de.bsvrz.buv.rw.basislib.perspectiveMenuEditor";
    try
    {
      PlatformUI.getWorkbench().showPerspective(perspectiveID, PlatformUI.getWorkbench().getActiveWorkbenchWindow());

      MenuSymbolLeisteDaten msld = new MenuSymbolLeisteDaten();
      // msld.setzeLeistenArt(enumLeistenArt.menue);
      msld.setzeLeistenArt(enumLeistenArt.symbol);
      EditorMenuSymbolLeisterInput ei = new EditorMenuSymbolLeisterInput(msld);
      IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
      try
      {
        page.openEditor(ei, "de.bsvrz.buv.rw.basislib.editorMenu");
      }
      catch (PartInitException pie)
      {
        _debug.info("Der Men- / Symbolleisteneditor konnte nicht " + "geffnet werden\n\t=> " + pie.toString());
      }

    }
    catch (WorkbenchException wbe)
    {
      _debug.info("Die Men- und Symbolleisteneditorperspektive " + "konnte nicht geffnet werden\n\t=> "
          + wbe.toString());
    }
  }

  @Override
  public void selectionChanged(IAction action, ISelection selection)
  {
  }

}
