/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

public class EditorOeffnenSicht extends ViewPart
{

	public static final String ID = "de.bsvrz.buv.rw.basislib.menu.editoren.EditorOeffnenSicht"; 
	
	private Composite top = null;
	private Group _gruppeAktionen = null;
	private Button _schaltflaecheSymbolleisteneditorLeer = null;
	private Button _schaltflaecheSymbolleisteneditorOeffnenDialog = null;
	private Button _schaltflaecheMenueLeistenEditor = null;
	private Button _schaltflaecheMenueLeistenEditorOeffnenDialog = null;
	private Text textInfo = null;
	@Override
	public void createPartControl(Composite parent)
	{
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		top = new Composite(parent, SWT.NONE);
		top.setLayout(gridLayout);
		erzeugeGruppeAktionen();
	}

	@Override
	public void setFocus()
	{
	}

	/**
	 * This method initializes gruppeAktionen
	 * 
	 */
	private void erzeugeGruppeAktionen()
	{
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.FILL;
		gridData11.grabExcessHorizontalSpace = true;
		gridData11.grabExcessVerticalSpace = true;
		gridData11.verticalAlignment = GridData.FILL;
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.verticalAlignment = GridData.CENTER;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.CENTER;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		_gruppeAktionen = new Group(top, SWT.NONE);
		_gruppeAktionen.setLayout(new GridLayout());
		_gruppeAktionen.setLayoutData(gridData);
		_gruppeAktionen.setText("Editoren ffnen");
		textInfo = new Text(_gruppeAktionen, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
		textInfo.setText("In dieser Sicht lassen sich die Editoren von Men- und Symbolleisten ffnen.\nDiese Sicht ist auch dann erreichbar, wenn man sich selbst,\nz.B. durch entfernen der entsprechenden Menpunkte,\nvon den jeweiligen Editoren ausgesperrt hat.");
		textInfo.setEditable(false);
		textInfo.setLayoutData(gridData11);
		_schaltflaecheMenueLeistenEditor = new Button(_gruppeAktionen, SWT.NONE);
		_schaltflaecheMenueLeistenEditor.setText("Menleisteneditor");
		_schaltflaecheMenueLeistenEditor
				.setToolTipText("ffnet einen leeren Menleisteneditor");
		_schaltflaecheMenueLeistenEditor.setLayoutData(gridData3);
		_schaltflaecheMenueLeistenEditor.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionMenuLeistenEditorLeer();
			}			
		});
		
		_schaltflaecheMenueLeistenEditorOeffnenDialog = new Button(_gruppeAktionen,
				SWT.NONE);
		_schaltflaecheMenueLeistenEditorOeffnenDialog
				.setText("Menleisteneditor mit ffnen-Dialog");
		_schaltflaecheMenueLeistenEditorOeffnenDialog
				.setToolTipText("ffnet einen Menleisteneditor mit Dialog zum Auswhlen bereits gespeicherter Menleisteneinstellungen");
		_schaltflaecheMenueLeistenEditorOeffnenDialog.setLayoutData(gridData4);		
		_schaltflaecheMenueLeistenEditorOeffnenDialog.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionMenuLeistenEditor();
			}			
		});
		
		_schaltflaecheSymbolleisteneditorLeer = new Button(_gruppeAktionen,
				SWT.NONE);
		_schaltflaecheSymbolleisteneditorLeer.setText("Symbolleisteneditor");
		_schaltflaecheSymbolleisteneditorLeer
				.setToolTipText("Liefert einen leeren Symbolleisteneditor");
		_schaltflaecheSymbolleisteneditorLeer.setLayoutData(gridData1);
		_schaltflaecheSymbolleisteneditorLeer.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSymbolLeistenEditorLeer();
			}			
		});
		
		_schaltflaecheSymbolleisteneditorOeffnenDialog = new Button(
				_gruppeAktionen, SWT.NONE);
		_schaltflaecheSymbolleisteneditorOeffnenDialog
				.setText("Symbolleisteneditor mit ffnen-Dialog");
		_schaltflaecheSymbolleisteneditorOeffnenDialog
				.setToolTipText("Liefert einen Symbolleisteneditor mit ffnen-Dialog zum ffnen von bereits vorhandenen Symbolleisteneinstellungen");
		_schaltflaecheSymbolleisteneditorOeffnenDialog.setLayoutData(gridData2);
		_schaltflaecheSymbolleisteneditorOeffnenDialog.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSymbolLeistenEditor();
			}			
		});
	}

	private void aktionMenuLeistenEditor()
	{
		Action action = EditorOeffnenAktionsSpeicher.getInstanz()
				.getActionMenuEditorOeffnenDialog();
		if (action != null)
		{
			action.run();
		}
	}

	private void aktionMenuLeistenEditorLeer()
	{
		Action action = EditorOeffnenAktionsSpeicher.getInstanz()
				.getActionMenuEditorLeer();
		if (action != null)
		{
			action.run();
		}
	}

	private void aktionSymbolLeistenEditor()
	{
		Action action = EditorOeffnenAktionsSpeicher.getInstanz()
				.getActionSymbolleisteEditorOeffnenDialog();
		if (action != null)
		{
			action.run();
		}
	}

	private void aktionSymbolLeistenEditorLeer()
	{
		Action action = EditorOeffnenAktionsSpeicher.getInstanz()
				.getActionSymbolleisteEditorLeer();
		if (action != null)
		{
			action.run();
		}
	}

}
