/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren.dialoge;

/**
 * Dient zur Auswahl, welche Leistenauswahl Radio Buttons angezeigt werden.
 * 
 * @author HofmannJ
 * 
 */
public enum EnumLeistenArt
{
	/**
	 * Aktivierte Darstellung der Radio Buttons fr Menleiste und Symbolleiste.
	 * Der Radio Button Statusleiste wird grau dargestellt.
	 */
	menuLeiste ("Menleiste", "Menleistenstruktur"),

	/**
	 * Aktivierte Darstellung der Radio Buttons fr Menleiste und Symbolleiste.
	 * Der Radio Button Statusleiste wird grau dargestellt.
	 */
	symbolLeiste("Symbolleiste", "Symbolleistenstruktur"),

	/**
	 * Aktivierte Darstellung des Radio Buttons Statusleiste. Die Radio Buttons
	 * fr Menleiste und Symbolleiste werden grau dargestellt.
	 */
	statusLeiste("Statusleiste", "Statusleistenstruktur");

	/**
	 * Speichert die Bezeichnung des Enumerators
	 */
	private String _bezeichnung = null;
	
	/**
	 * Speichert die Beschreibung des Enumerators
	 */
	private String _beschreibung = null;

	/**
	 * Konstruktor, bernimmt Bezeichnung und Beschreibung.
	 * @param bezeichnung Bezeichnung
	 * @param beschreibung Beschreibung
	 */
	private EnumLeistenArt(String bezeichnung, String beschreibung)
	{
		this._beschreibung = beschreibung;
		this._bezeichnung = bezeichnung;
	}
	
	/**
	 * Liefert die Bezeichnung.
	 * @return Bezeichnung
	 */
	public String getBezeichnung()
	{
		return _bezeichnung;
	}
	
	/**
	 * Liefert die Beschreibung.
	 * @return Beschreibung
	 */
	public String getBeschreibung()
	{
		return _beschreibung;
	}
		
	public String toString()
	{
		return _bezeichnung;
	}
}
