/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.seiteneinstellungen;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public class TestSeitenEinstellungen
{

	private Shell sShell = null;

	private Composite compositeOben = null;

	private Composite compositeUnten = null;

	private Composite compositeKontrolle = null;

	private Button buttonOk = null;

	private Button buttonAbbruch = null;

	private Zusammelstellung _compositeKopfFusszeilen = null;

	/**
	 * This method initializes compositeOben
	 * 
	 */
	private void createCompositeOben()
	{
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.FILL;
		gridData11.grabExcessHorizontalSpace = true;
		gridData11.grabExcessVerticalSpace = true;
		gridData11.verticalAlignment = GridData.FILL;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		compositeOben = new Composite(sShell, SWT.NONE);
		compositeOben.setLayout(new GridLayout());
		compositeOben.setLayoutData(gridData);
		_compositeKopfFusszeilen = new Zusammelstellung(compositeOben, SWT.NONE);
		_compositeKopfFusszeilen.setLayoutData(gridData11);

		String[] texte = new String[] { "1", "2", "3", "4", "5", "6" };
		// String[] texte = new String[]{"1", "2", "3", "4", "6"};
		try
		{
			_compositeKopfFusszeilen.setKopfFussZeilen(texte);
		} catch (IllegalArgumentException iae)
		{
			iae.printStackTrace();
		}

	}

	/**
	 * This method initializes compositeUnten
	 * 
	 */
	private void createCompositeUnten()
	{
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.CENTER;
		compositeUnten = new Composite(sShell, SWT.NONE);
		compositeUnten.setLayout(new GridLayout());
		createCompositeKontrolle();
		compositeUnten.setLayoutData(gridData1);
	}

	private void aktionSchliessen()
	{
		sShell.dispose();
	}

	/**
	 * This method initializes compositeKontrolle
	 * 
	 */
	private void createCompositeKontrolle()
	{
		RowLayout rowLayout = new RowLayout();
		rowLayout.pack = false;
		GridData gridData2 = new GridData();
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		gridData2.horizontalAlignment = GridData.END;
		compositeKontrolle = new Composite(compositeUnten, SWT.NONE);
		compositeKontrolle.setLayoutData(gridData2);
		compositeKontrolle.setLayout(rowLayout);
		buttonOk = new Button(compositeKontrolle, SWT.NONE);
		buttonOk.setText("OK");
		buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				if (_compositeKopfFusszeilen != null)
				{
					String[] kopfFussZeilen = _compositeKopfFusszeilen
							.getKopfFussZeilen();
					for (String string : kopfFussZeilen)
					{
						System.out.println("Erfasst: " + string);
					}
				}

				aktionSchliessen();
			}
		});

		buttonAbbruch = new Button(compositeKontrolle, SWT.NONE);
		buttonAbbruch.setText("Abbruch");		
		buttonAbbruch.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSchliessen();
			}			
		});
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		/*
		 * Before this is run, be sure to set up the launch configuration
		 * (Arguments->VM Arguments) for the correct SWT library path in order to
		 * run with the SWT dlls. The dlls are located in the SWT plugin jar. For
		 * example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 * installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		TestSeitenEinstellungen thisClass = new TestSeitenEinstellungen();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed())
		{
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell()
	{
		sShell = new Shell();
		sShell.setText("Test Seiteneinstellungen");
		createCompositeOben();
		createCompositeUnten();
		sShell.setLayout(new GridLayout());
		sShell.setSize(new Point(800, 600));
	}

}
