/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.menu.xml.datenstruktur;

/**
 * Liefert die Bezeichnungen der in *.menu.* gebruchlichen XML-Elemente und Attribute.
 * 
 * @version $Revision: 1.1 $ / $Date: 2009/12/02 09:21:05 $ / ($Author: HofmannJ $)
 * 
 * @author HofmannJ
 * 
 */
public class XmlBezeichnerMenuSymbol
{
  /*
   * Elemente
   */
  /**
   * Element fr die Menleiste
   */
  // public static final String elementMenuLeiste = "menubar";
  public static final String elementMenuLeiste = "menuleiste";

  public static final String elementSymbolLeiste = "symbolleiste";

  /**
   * Element fr ein Submen
   */
  public static final String elementSubMenu = "submenu";

  /**
   * Element fr ein Men
   */
  public static final String elementMenu = "menu";

  /**
   * Element fr ein Item
   */
  public static final String elementItem = "item";

  /**
   * Element fr einen Separator
   */
  public static final String elementSeparator = "separator";

  /**
   * Element fr einen GroupMarker
   */
  public static final String elementGroupMarker = "groupmarker";

  /*
   * Attribute
   */

  /**
   * Attribut Id
   */
  public static final String attId = "id";

  /**
   * Attribut Name
   */
  public static final String attName = "name";

  /**
   * Attribut ActionId als Verweis auf die Action i.d. ElementRegistrierung.
   */
  public static final String attActionId = "actionId";

  /**
   * Attribut fr Runterklappaktion, kann "ja" oder "nein" sein.
   */
  public static final String attItemAusklappbar = "actionRunterKlappen";

  // public static final String attItemAusklappbar = "ausklappbar";

  /**
   * XML-Dateicodierung
   */
  public static final String xmlCodierung = "ISO-8859-1";

  /**
   * XML DocTypeElement Menleiste
   */
  public static final String xmlDocTypeElementNameMenuLeiste = "elmentMenuLeiste";

  /**
   * XML DocTypeElement Symbolleiste
   */
  public static final String xmlDocTypelementNameSymbolLeiste = "elmentMenuLeiste";

  /**
   * XML DocTyp PublicID
   */
  public static final String xmlDocTypePublicId = "-//basislib//DTD Dokument//DE";

  /**
   * XML DTD Menleiste
   */
  public static final String xmlDocTypeSystemIdMenuLeiste = "menuleiste.dtd";

  /**
   * XML DTD Symbolleiste
   */
  public static final String xmlDocTypeSystemIdSymbolLeiste = "symbolleiste.dtd";

}
