/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.menu.xml.datenstruktur;

import org.jdom.Element;

/**
 * Klasse zur Reprsentation des XML-Elementes Symbolleiste.
 * 
 * @version $Revision: 1.1 $ / $Date: 2009/12/02 09:21:05 $ / ($Author: HofmannJ $)
 * 
 * @author HofmannJ
 * 
 */
public class XmlElementSymbolLeiste
{
  private Element _elSymbolleiste = null;

  /**
   * Parameterloser Konstruktor.
   * 
   */
  public XmlElementSymbolLeiste()
  {
  }

  public void generiereElement()
  {
    _elSymbolleiste = new Element(XmlBezeichnerMenuSymbol.elementSymbolLeiste);
  }

  /**
   * Generiert die Objektreprsentation einer Symbolleiste aus einem <code>Element</code>. Es wird hierzu kein Clone
   * erstellt, folglich bleiben Eltern und Kinder des Elements erhalten.
   * 
   * @param el
   *          <code>Element</code>, zu dem die Objektreprsentation erstellt wird.
   */
  public void generiereElement(Element el)
  {
    if (el.getName().equalsIgnoreCase(XmlBezeichnerMenuSymbol.elementSymbolLeiste))
    {
      this._elSymbolleiste = el;
      // //Attribute, fals ntig, einlesen
      // _id = el.getAttributeValue(_elMenuAttributId);
    }
  }

  /**
   * Generiert die Objektreprsentation einer Symbolleiste aus einem <code>Element</code>. Es handelt sich hierbei um
   * eine flache Kopie, Eltern- und Kindelemente gehen verloren.
   * 
   * @param el
   *          <code>Element</code>, von dem eine flache Kopie erstellt werden soll.
   */
  public void generiereAusElement(Element el)
  {
    if (el.getName().equalsIgnoreCase(XmlBezeichnerMenuSymbol.elementSymbolLeiste))
    {
      // //Attribute auslesen falls notwendig
      // _id = el.getAttributeValue(_elMenuAttributId);
      generiereElement();
    }
  }

  /**
   * Liefert des {@link Element} der Symbolleiste.
   * 
   * @return {@link Element} der Symbolleiste.
   */
  public Element getElementSymbolleiste()
  {
    return _elSymbolleiste;
  }

  /**
   * Liefert eine String-Reprsentation der Symbolleiste.
   * 
   * @return Stringreprsentation der Symbolleiste.
   */
  public String toString()
  {
    String returnString = "Element: " + XmlBezeichnerMenuSymbol.elementSymbolLeiste + " (keien Attribute)";
    return returnString;
  }

}
